#include "display.h"
#include "util.h"

void print_board(
    const state_t *state)
{
    int x, y, i, j;

    x = 2;
    y = 2;
    box(state->menu_win, 0, 0);
    for (i = 0; i < state->size; ++i)
        for (j = 0; j < state->size; ++j)
        {
            int val = state->board[i][j];
            if (val <= 0)
            {
                if (!state->debug)
                {
                    mvwprintw(state->menu_win, y + i, x + 3 * j, " * ");
                }
                else
                {
                    mvwprintw(state->menu_win, y + i, x + 3 * j, "-%d-", abs(val));
                }
                continue;
            }
            wattron(state->menu_win, COLOR_PAIR(val));
            if (state->highlight_r == i && state->highlight_c == j)
            {
                // Highlight the present choice
                wattron(state->menu_win, A_REVERSE);
                mvwprintw(state->menu_win, y + i, x + 3 * j, " %d ", val);
                wattroff(state->menu_win, A_REVERSE);
            }
            else
            {
                mvwprintw(state->menu_win, y + i, x + 3 * j, " %d ", val);
            }
            wattroff(state->menu_win, COLOR_PAIR(val));
        }
    wrefresh(state->menu_win);
}
